-- #102
CREATE TABLE appointment (
     appointmentid        integer  not null
,    calendarid           integer  not null
,    userid               integer  null
,    startdate            datetime  not null
,    enddate              datetime  not null
,    quantity             decimal(19,4)  not null
,    acceptedon           datetime  null
,    cancelledon          datetime  null
,    selectedoptions      varchar(255)  null
,    selectedoptionids    varchar(255)  null
,    isstorefront         bool  not null
,    sequence             integer  null

,   constraint pk_appointment                   primary key (appointmentid)
,   constraint fk_appointment_calendarid        foreign key (calendarid)
        references calendar                         (calendarid)
,   constraint fk_appointment_appointmentid     foreign key (appointmentid)
        references object                           (objectid)
,   constraint fk_appointment_userid            foreign key (userid)
        references users                            (userid)
)
GO
CREATE INDEX i_appointment_calendar ON appointment (calendarid)
GO

CREATE INDEX i_appointment_user ON appointment (userid)
GO
