-- #101
CREATE TABLE calendar (
     calendarid           integer  not null
,    basecalendarid       integer  null
,    acceptwithreservation bool  not null
,    hasownbookingperiod  bool  not null
,    istwoweeks           bool  not null
,    onlybookingperiod    bool  not null
,    cancustomerdefinedappduration bool  not null
,    lastbookingamount    integer  null
,    lastbookingunitid    integer  null
,    lastcancelamount     integer  null
,    lastcancelunitid     integer  null
,    appointmentinterval  integer  null
,    appdurationstep      integer  null
,    appdurationunitid    integer  null
,    appdurationamount    integer  null

,   constraint pk_businesshour                  primary key (calendarid)
,   constraint fk_calendar_calendarid           foreign key (calendarid)
        references object                           (objectid)
,   constraint fk_calendar_lastbookingunitid    foreign key (lastbookingunitid)
        references unitofmeasurement                (unitid)
,   constraint fk_calendar_lastcancelunitid     foreign key (lastcancelunitid)
        references unitofmeasurement                (unitid)
,   constraint fk_calendar_basecalendarid       foreign key (basecalendarid)
        references calendar                         (calendarid)
,   constraint fk_calendar_appdurationunitid    foreign key (appdurationunitid)
        references unitofmeasurement                (unitid)
)
GO
CREATE INDEX i_calendar_base ON calendar (basecalendarid)
GO

CREATE INDEX i_calendar_lastbookingunitid ON calendar (lastbookingunitid)
GO

CREATE INDEX i_calendar_lastcancelunitid ON calendar (lastcancelunitid)
GO

CREATE INDEX i_calendar_appdurationunitid ON calendar (appdurationunitid)
GO
