-- #104
CREATE TABLE shorturl (
     shorturlid           integer  not null AUTO_INCREMENT
,    siteid               integer  not null
,    languageid           integer  not null
,    contentobjectid      integer  not null
,    uri                  varchar(255) CHARACTER SET ascii COLLATE ascii_general_ci not null 


,   constraint pk_shorturl                      primary key (shorturlid)
,   constraint fk_shorturl_siteid               foreign key (siteid)
        references site                             (siteid)
,   constraint fk_shorturl_languageid           foreign key (languageid)
        references language                         (languageid)
,   constraint fk_shorturl_contentobjectid      foreign key (contentobjectid)
        references contentobject                    (contentobjectid)
)
GO
CREATE UNIQUE INDEX u_shorturl_site_uri ON shorturl (siteid, uri)
GO

CREATE UNIQUE INDEX u_shorturl_object_language ON shorturl (contentobjectid, languageid)
GO

CREATE INDEX i_shorturl_languageid ON shorturl (languageid)
GO
