use strict;
use DE_EPAGES::Core::API::Log qw ( GetLog LogContext SetLogLevel );
use DE_EPAGES::Core::API::Log4perl::NDCHash;
use DE_EPAGES::Core::API::Script qw ( RunScript );
use Test::More;
use Log::Log4perl::NDC;

RunScript( Debug => 1, Sub => sub {
    my %data = (  'Test' => 'abc' );
    my $Obj = DE_EPAGES::Core::API::Log4perl::NDCHash->new(\%data);
    is($Obj . "", '{"Test":"abc"}', 'toString on NDCHash');

    LogContext({'Test1'=> 'abc'}, sub {
        is('{"Test1":"abc"}',Log::Log4perl::NDC->get(), 'LogContext Level1');
        LogContext({'Test2' => 'xyz'}, sub {
            is('{"Test2":"xyz","Test1":"abc"}', Log::Log4perl::NDC->get(), 'LogContext Level2');
            LogContext({'Test3' => 'xx'}, sub {
                is('{"Test2":"xyz","Test1":"abc","Test3":"xx"}', Log::Log4perl::NDC->get(), 'LogContext Level3');
            });
        });
        LogContext({'Test1' => 'def'}, sub {
            is('{"Test1":"def"}',Log::Log4perl::NDC->get(), 'LogContext with override.');
        });
        is('{"Test1":"abc"}',Log::Log4perl::NDC->get(), 'LogContex after override');
    });

    SetLogLevel('DEBUG', sub {
        LogContext({'Test1' => 'def'}, sub {
            GetLog('DE_EPAGES::Core::t::NDCHash')->debug('testing NDCHash');
        });
    },'DE_EPAGES::Core::t::NDCHash');

    pass('passed - check your debug.log for NDC output');
});

done_testing();
