-- #102
CREATE TABLE customer (
     customerid           integer  not null
,    shopid               integer  not null
,    customergroupid      integer  null
,    billingaddressid     integer  null
,    ishtmlemailallowed   bool  not null
,    isdoorderallowed     bool  not null
,    taxareaid            integer  null
,    taxmodel             bool  not null
,    isratinginvitationallowed bool  not null

,   constraint pk_customer                      primary key (customerid)
,   constraint fk_customer_customerid           foreign key (customerid)
        references object                           (objectid)
,   constraint fk_customer_billingaddressid     foreign key (billingaddressid)
        references address                          (addressid)
,   constraint fk_customer_customergroupid      foreign key (customergroupid)
        references customergroup                    (customergroupid)
,   constraint fk_customer_shopid               foreign key (shopid)
        references shop                             (shopid)
,   constraint fk_customer_taxareaid            foreign key (taxareaid)
        references taxarea                          (taxareaid)
)
GO
CREATE INDEX i_customer_shop ON customer (shopid)
GO

CREATE INDEX i_customer_group ON customer (customergroupid)
GO

CREATE INDEX i_customer_billingid ON customer (billingaddressid)
GO

CREATE INDEX i_customer_taxareaid ON customer (taxareaid)
GO
