/*
 * @copyright		© Copyright 2006-2012, epages GmbH, All Rights Reserved.
 *
 * @module			de_epages.externalcontent.gadget.googleplus
 *
 * @revision		$Revision: 1.3.4.2 $
 */

jQuery.plugin( 'de_epages.externalcontent.gadget.googleplus', {
	plugin:	['de_epages.core', 'jQuery.ui.widget']
}, function ($) {
	// Constants.
	var gClassNames = 'SocialWeb',

		ajaxCache;

	// The actual widget.
	$.widget('de_epages.externalcontent.gadget.Googleplus', {
		options : {
			href : ep.config.canonicalUrl ? ep.config.canonicalUrl : ep.config.webUrl,
			// URL to which +1 should reference.
			layout : 'standard',
			// String specifying the size of the button.
			// Possible values: 'small', 'medium', 'standard', 'tall'.
			type : 'bubble'
			// String specifying the annotation (counter) shown.
			// Possible values: 'none', 'bubble'.
		},

		_create : function () {
			var self = this,
			o = self.options;
			// Tell google to wait for us to tell *gapi.plusone* to render the button. (See below.)
			window['___gcfg'] = {
				parsetags : 'explicit',
				lang : ep.config.language
			};
			// Append *container* for gadget to *self.element*.
			self.container = $('<div>').appendTo(self.element.addClass(gClassNames));

			// Load script from Google.
			if (!ajaxCache) {
				if (window.gapi && gapi.plusone) {
					ajaxCache = $.Deferred().resolve()
				}
				else {
					ajaxCache = $.ajax({
						dataType : 'script',
						url : 'https://apis.google.com/js/plusone.js',
						cache : true
					})
				}
			}

			ajaxCache.done(function(){
				// Render button.
				gapi.plusone.render(
					self.container[0],
					{
						href: o.href,
						size: o.layout,
						annotation: o.type
					}
				);
			});
		},

		destroy : function () {
			var self = this;
	 		// Remove all traces of the widget.
	 		self.element.removeClass(gClassNames);
			self.container.remove();
			self.Inherited(arguments);
		}

	});

});