/*
 * @copyright   © Copyright 2006-2012, epages GmbH, All Rights Reserved.
 *
 * @module      de_epages.externalcontent.gadget.otherbuttons
 *
 * @revision    $Revision: 1.4.4.1 $
 */

jQuery.plugin('de_epages.externalcontent.gadget.otherbuttons', {
	plugin : ['jQuery.tmpl', 'jQuery.ui.widget', 'ep.core']
}, function ($) {

	// Constants.
	var gClassNames = 'SocialWeb SocialBookmarks',
		// Will be added to *self.element*.
		iconPath = epConfig.storeRoot + '/SF/SocialWeb/ico_bookmark_',
		// Start of icon path of respective services.
		services = {
			digg : {
				url : 'http://digg.com/submit?url=',
				alt : 'digg'
			},
			delicious : {
				url : 'http://www.delicious.com/save?url=',
				alt : 'delicious'
			},
			stumbleupon : {
				url : 'http://www.stumbleupon.com/submit?url=',
				alt : 'StumbleUpon'
			},
			technorati : {
				url : 'http://technorati.com/faves?add=',
				alt : 'Technorati'
			},
			mrwong : {
				url : 'http://www.mister-wong.de/addurl/?bm_url=',
				alt : 'Mr Wong'
			}
		},
		// Service constants.
		templateId = 'de_epages.externalcontent.gadget.otherbuttons';

	// Render and cache template.
	$.template(templateId, '<a class="RightMargin" href="${url}${$item.url}" target="_blank"><img src="' + iconPath + '${$item.service}.png" alt="${alt}"/></a>');

	// The actual widget.
	$.widget('de_epages.externalcontent.gadget.Otherbuttons', {

		options : {
			services : [] // Array of strings with the property names of *services*, see above (Constants).
		},

		_create : function () {
			var self = this,
				o = self.options,
				templateElems = [],
				service,
				i, // Loop variable.
				servicesLength = o.services.length;

			for (i = 0; i < servicesLength; i++) {
				service = o.services[ i ];
				// Create button using the template and append to *self.element*.
				$.merge(
					templateElems,
					$.tmpl(templateId, services[ service ], {
						url : ep.config.canonicalUrl ? ep.config.canonicalUrl : ep.config.webUrl,
						service : service
					}).get()
				);
			}
			// "Append" *templateElems* and "addClass" *gClassNames* to *self.element*.
			self.renderedTemplates = $(templateElems).appendTo(self.element.addClass(gClassNames));
		},

		destroy : function () {
			var self = this;
			// Remove all traces of the widget.
			self.element.removeClass(gClassNames);
			self.renderedTemplates && self.renderedTemplates.remove();
			self.Inherited(arguments);
		}

	});

});