/*
 * @copyright		© Copyright 2006-2012, epages GmbH, All Rights Reserved.
 *
 * @module			ep.ui.slides
 *
 * @revision		$Revision: 1.3.4.2 $
 */

jQuery.plugin( "ep.mobile.slides", {
	plugin:	["ep.ui.core", "ep.ui.slidebox", "jQuery.event.special.touch", "jQuery.tmpl", "jQuery.ui.widget"],
	tmpl:	["ep.mobile.slides"]
}, function( $, undefined ){

	var body,

		win = $(window),

		mobile,

		preventDefault = function( event ){
			event.preventDefault();
		};

	$.widget( "ep.mobile.Slides", {
		options: {
			images			: "img",			// selector / array of data / data / image node / array of image nodes / jQuery object
		},

		_create: function(){
			var self = this,
				o = self.options,
				imgs = self.images = ep.ui.imgData(o.images)
					.on("change", self.Proxy("_change")),
				tmplData = {
					tBack		: "Back",
					tFullSize	: "Fullsize",
					images		: imgs
				};

			win.on("resize", self.Proxy("_resize"));

			self.element
				.on("click", self.Proxy("_open"));

			// load template and add element names to instance
			$.extend( self, $.tmpl( "ep.mobile.slides", [tmplData] ).appendTo("body").hide().tmplItem("elements") );

			self.back
				.on("click", self.Proxy("close"));

			self.fullsize
				.on("click", self.Proxy("_fullsize"));

			self.body
				.on("changeslide", function( event, o ){
					self.count.text( o.page + " / " + o.pages );
					imgs.current( o.page-1 );
				})
				.uiSlidebox({
					view: 1,
					arrow: true,
					padding: false
				});

			self.foot
				.on("click", "li", function(){
					imgs.current( $(this).data("index") );
				})
				.uiSlidebox({
					view: 4,
					arrow: true,
					padding: true
				});

			self.scrollTop = 0;

			self._setOptions(o);
		},

		_init: function(){
			var self = this;

			if( !body ){
				body = $("body");
			}

			if( !mobile ){
				mobile = $(".MobileLayout");
			}

			self._resize();
		},

		_fullsize: function(event){
			event.preventDefault();
			location.href = this.images.current().href;
		},

		_resize: function(){
			this.container.height( win.height() + ( /iPhone/.test(navigator.userAgent) ? 60 : 0) );
		},

		_change: function(){
			var self = this;

			self.body.uiSlidebox("goTo", self.images.currentItem + 1 );
			self.foot.uiSlidebox("goTo", Math.floor(self.images.currentItem / 4) + 1 );
		},

		_open: function( event ){
			event.preventDefault();
			this.open();
			this._resize();
		},

		open: function(){
			var self = this;

			// save current scroll position to restore
			self.scrollTop = body.prop("scrollTop");

			body.prop("scrollTop",0)
				.on("scroll.mobileSlides", preventDefault);

			self.container.show();
			mobile.hide(); // Prevent mark of links in bottom layers in Android 2.x
		},

		close: function(){
			var self = this;

			body.prop("scrollTop",self.scrollTop)
				.off("scroll.mobileSlides", preventDefault);

			mobile.show(); // Prevent mark of links in bottom layers in Android 2.x
			self.container.hide();
		},

		destroy: function(){
			var self = this;

			self.images.off(".mobileSlides");
			self.container.remove();
			self.Inherited(arguments);
		}
	});

});