/*
 * @copyright		© Copyright 2006-2012, epages GmbH, All Rights Reserved.
 *
 * @module			ep.ui.slider
 *
 * @revision		$Revision: 1.5.4.3 $
 */

jQuery.plugin('ep.ui.slider', ['ep.core', 'ep.ui.tooltip', 'jQuery.ui.slider'], function ($) {

	$.widget('ep.ui.Slider', $.ui.slider, {

		options : {
			label :	'',
			unit : '',
			info : null
		},

		_create : function () {
			var self = this,
					o = $.extend(self.options, $.parseJSON(self.element.attr('data-ep-ui-slider')));

			// Create UI elements, add CSS classes and set initial texts.
			self.labelNode = $('<div>')
				.text(o.label)
				.addClass('ep-uiSlider-label');
			if (o.info) {
					self.infoNode = ep('<span>').text(o.info.alt);
					self.labelNode.append($('<img>')
						.addClass('BubbleHelp')
						.attr({
							'src' : o.info.src,
							'alt' : o.info.alt
						}), self.infoNode);
			}
			self.valueNode = $('<div>').addClass('ep-uiSlider-value');
			self.sliderNode = $('<div>').addClass('ep-uiSlider-slider');

			self.element
				.addClass('ep-uiSlider-wrap')
				.append(
					self.labelNode,
					self.valueNode,
					self.sliderNode
				);

			// Create (ep.ui) *tooltip*.
			if (o.info) {self.infoNode.uiTooltip();}

			// Create (jQuery) *slider*.
			self.element = self.sliderNode;
			self.Inherited(arguments);
			self.element = self.element.parent();

			// Add event handling.
			self.element.on('slide', function (event, ui) {
				self.valueNode.text(ui.value + (o.unit ? (' ' + o.unit) : ''));
			});

			// Render *valueNode*.
			self.element.trigger('slide', {value : o.value});
		},

		destroy : function () {
			var self = this;
			self.labelNode.remove();
			self.valueNode.remove();
			self.element.removeClass('ep-uiSlider-wrap');
			self.Inherited(arguments);
			self.sliderNode.remove();
		}

	});

});