/*
	Please pay attention when you change this plugin.
	Due to the cartridge dependencies the plugin was saved in ExternalContent and MediaGallery.
	That's why you have to change it in both cartridges.
*/

/*
 * @dictionary		ep.dict
 *
 * @translation		{MediaGroup}
 * 								{Media}
 * 								{Gadget}
 * 								{RSS}
 */

CKEDITOR.plugins.add( 'epMediaGroup',
{
	requires : [ 'menubutton' ],

	init: function( editor ){
	var menuGroup = 'mediaGroup',
		epDict = ep.dict('ep.dict'),
		translations = {
			tMedia: epDict.translate('Media'),
			tMediaGroup: epDict.translate('MediaGroup'),
			tGadget: epDict.translate('Gadget'),
			tRSS: epDict.translate('RSS')
		},
		uiMenuItems = {},
		features = top.ep.config.features;

	// add menu group
	editor.addMenuGroup( menuGroup );

	// create menu entries, commands and event listener for different line heights
	if(features.MediaGallery){
		uiMenuItems.image = {
			label : editor.lang.common.image,
			command : 'epImage',
			group : menuGroup
		};
	}
	if(features.Gadget){
		uiMenuItems.gadget = {
			label : translations.tGadget,
			command : 'epGadget',
			group : menuGroup,
			icon: this.path + '../epGadget/images/gadget.png'
		};
	}
	if(features.RSS){
		uiMenuItems.rss = {
			label : translations.tRSS,
			command : 'epRSS',
			group : menuGroup,
			icon: this.path + '../epRSS/images/rss.png'
		};
	}

	// add items to the menu
	editor.addMenuItems( uiMenuItems );

	// create menu button
	editor.ui.add( 'epMediaGroup', CKEDITOR.UI_MENUBUTTON,{
		label : translations.tMediaGroup,
		title : translations.tMediaGroup,
		modes : { wysiwyg : 1 },
		icon: this.path + 'images/mediagroup.png',
		onMenu : function(){
			return {
				image  : CKEDITOR.TRISTATE_OFF,
				media : CKEDITOR.TRISTATE_OFF,
				gadget : CKEDITOR.TRISTATE_OFF,
				rss : CKEDITOR.TRISTATE_OFF
			};
		}
	});
}

} );