-- #103
CREATE TABLE paymentlevel (
     paymentlevelid       integer  not null AUTO_INCREMENT
,    paymentmethodid      integer  not null
,    currencyid           char(3)  not null
,    basevalue            decimal(19,4)  not null
,    lowerbound           double  null
,    upperbound           double  null
,    multiplier           double  null

,   constraint pk_paymentlevel                  primary key (paymentlevelid)
,   constraint fk_paymentlevel_paymentmethodid  foreign key (paymentmethodid)
        references paymentmethod                    (paymentmethodid)
,   constraint fk_paymentlevel_currencyid       foreign key (currencyid)
        references currency                         (currencyid)
)
GO
CREATE INDEX i_shippinglevel_shippingmethod ON paymentlevel (paymentmethodid, currencyid)
GO

CREATE INDEX i_shippinglevel_currencyid ON paymentlevel (currencyid)
GO
