/*
 * @copyright		© Copyright 2006-2012, epages GmbH, All Rights Reserved.
 *
 * @module			de_epages.presentation.inc.mainMenu
 *
 * @revision		$Revision: 1.3 $
 */

jQuery.plugin('de_epages.presentation.inc.mainMenu', {
	plugin : [
		'jQuery.tmpl',
		'de_epages.core'
	],
	tmpl : [
		'de_epages.presentation.inc.mainMenu'
	],
}, function ($) {
	$.extend($.scope("de_epages.presentation.inc"), {
		mainMenu : function (selector, updates) {
			var $node = $(selector),
					menu = $node.data('menu');
			// Render template (which also handles updating menu items),
			// append to *node* and assign *onClick* handler, if so desired.
			$.tmpl('de_epages.presentation.inc.mainMenu', menu, {
				'updates' : updates,
				// Setup class attribute of menu item's *li* node.
				'class' : function () {
					var self = this,
							data = self.data,
							classAttr = '',
							status;

					if (data.children && data.children.length) {classAttr += 'hasChildren';}
					if (self.followedBySeparator) {classAttr += (classAttr.length ? ' ' : '') + 'Separator';}
					switch (data.status) {
						case 'DISABLED' : classAttr += (classAttr ? ' ' : '') + 'Disabled'; break;
						case 'FEATURE_DISABLED' : classAttr += (classAttr ? ' ' : '') + 'FeatureDisabled'; break;
						case 'HIDDEN' : classAttr += (classAttr ? ' ' : '') + 'Hidden'; break;
						case 'SELECTED' : classAttr += (classAttr ? ' ' : '') + 'Selected'; break;
						default : break;
					}
					if (!classAttr) {return '';}
					else {return 'class="' + classAttr + '"';}
				},
				// Update menu item.
				'setup' : function () {
					var self = this,
							data = self.data;

					if (update=self.updates[data.menuId]) {
						$.extend(data, update);
					}
					return "";
				}
			})
			.appendTo($node)
			.find('.ep-menu-click').each(function (i) {
				var $this = $(this);
				$this.on('click', $this.tmplItem('data')['onClick'])
			});
		}
	});
});