jQuery.plugin("de_epages.remotesearch.inc.resultpagehandler", {
	plugin: ["jQuery.i18n","jQuery.fn.class", "ep.core", "ep.fn.busy", "ep.ui.form"],
	DOM: true
}, function($){
	$.scope("de_epages.remotesearch.inc").resultpagehandler = function(options){

		var
			// Init options
			o = $.extend({
				viewAction: "View",
				languageId: ep.config.languageId,
				currency: $.i18n.settings.currency,
				historyInit: {
					results: "",
					facets: "",
					facetsForm: ""
				}
			}, options),

			// Page content area
			page = ep(".GeneralLayout"),

			// Navbars (left / right)
			navbar = $(".NavBarLeft > .PropertyContainer > .SizeContainer, .NavBarRight > .PropertyContainer > .SizeContainer"),

			// Category tree box
			category = navbar.children(".CategoriesBox"),

			// Search results area
			results = $("#RemoteSearchResults"),

			// Search facets area
			facets = ep("#RemoteSearchFacets"),

			// Form of facets
			facetsForm = facets.find("form"),

			// Timeout id holder
			delayTimout,

			// Delayed auto sumbit
			delaySubmit = function(){
				clearTimeout(delayTimout);
				
				// Delay submit after user input handling
				delayTimout = setTimeout(function(){
					facetsForm.trigger("submit");
				}, 1800);
			};

		// Set factets area position
		if( navbar.length ){
			if (category.length){
				if (jQuery.contains(navbar.first()[0], category[0])) {
					navbar = navbar.first();
				}
				else if (jQuery.contains(navbar.last()[0], category[0])) {
					navbar = navbar.last();
				}

				category.remove();
			}
			else {
			navbar = navbar.first();
			}

			navbar
				.prepend(facets);

			navbar
				.children(".SearchBox, .SearchElement")
				.first()
				.prependTo(navbar);

			navbar
				.children()
				.removeClass(/NavBarElement\d+/)
				.each(function(i, node){
					$(this).addClass("NavBarElement"+i);
				});
		}
		else{
			facets
				.addClass("NavBarMiddle");
		}

		// Without AJAX
		facetsForm.uiForm();

		// Register input event handling
		facetsForm
			.on("change", "input:not(:text)", function(){
				facetsForm.trigger("submit");
			})
			.on("keyup", "input[name] + input:text", function(){
				var input = $(this),
					slide = input.closest("li").find(".ui-slider"),
					val = input.val(),
					value = $.i18n.parseNumber(val),
					values = slide.slider("option", "values");
				values[input.is(".FacetRangeMin") ? 0 : 1] = value;

				// Set value to named (hidden) input
				input.prev().val( val );

				// Set value to slider
				if( value !== NaN ){
					slide.slider("option", "values", values);
				}
			})
			.on("slide", ".ui-slider", function(){
				var slide = $(this),
					values = slide.slider("values"),
					format = slide.data("format") || 'n',
					vals = [$.i18n.formatNumber(values[0], format), $.i18n.formatNumber(values[1], format)],
					input = slide.closest("li").find("input");

				input.filter(".FacetRangeMin").val( vals[0] );
				input.filter(".FacetRangeMax").val( vals[1] );

				input.trigger('focus')		// Trigger non native placeholder handling
					.trigger('validate'); // Validate values

				delaySubmit();
			})
			.on("click", "a.RemoteSearchFacetsReset", function(){
				$(this)
					.closest('.RemoteSearchFacet, form')
					.find("input:checkbox, input:radio")
						.attr("checked",false)
					.end()
					.find("input:text")
						.val("")
						.trigger("keyup")
					.end();

				facetsForm.trigger("submit");
			});
	};
});