#========================================================================================
# package      DE_EPAGES::RemoteSearch::t::SearchReplicationToken
# state        private
#========================================================================================
package DE_EPAGES::RemoteSearch::t::SearchReplicationToken;
use base Test::Class;

use DE_EPAGES::Database::API::Connection qw ( GetTestSite RunOnStore );
use DE_EPAGES::Core::API::Script qw ( RunScript );
use DE_EPAGES::RemoteSearch::API::Table::SearchReplicationToken qw (
    GetAllPKeySearchReplicationTokens 
    IncrementAndGetReplicationToken );

use Test::More;
use strict;

sub TestGetReplicationToken : Test(2) {
    my $aTokenIDs = GetAllPKeySearchReplicationTokens();
    is( scalar @$aTokenIDs, 1, 'ok: one token exists' );
    cmp_ok( $aTokenIDs->[0], '>', 0, 'replication token exists and > 0' );
}

sub TestIncrementAndGetReplicationToken : Test {
    my $self = shift;

    # this can fail, if we have other activity on the testsite... but should be fairly seldom
    my $Token1 = IncrementAndGetReplicationToken();
    my $Token2 = IncrementAndGetReplicationToken();

    is( $Token1 + 1, $Token2, 'Increment and get token' );
}

RunScript(
    Sub => sub {
        RunOnStore(
            'Store' => GetTestSite(),
            'Sub'   => sub {
                Test::Class->runtests;
            }
        );
    }
);
