#========================================================================================
# package      DE_EPAGES::RemoteSearch::t::WebserviceClient
# state        private
#========================================================================================
package DE_EPAGES::RemoteSearch::t::WebserviceClient;
use base Test::Class;

use strict;
use warnings;

use JSON;
use Test::More;
use DE_EPAGES::RemoteSearch::API::Object::WebserviceClient;
use DE_EPAGES::Core::API::Script qw ( RunScript );

sub test : Test(no_plan) {
    my $self = shift;
    my $Client = DE_EPAGES::RemoteSearch::API::Object::WebserviceClient->new(
      'BaseURL'    => 'http://localhost:9091/rs/',
      'Datasource' => 'Store',
      'Resource'   => 'shopGUID',
    );
    is($Client->shopOperationUrl('update')->as_string, 'http://localhost:9091/rs/product/Store/shopGUID/update', 'shopOperationUrl');
    is($Client->baseDatasourceUrl()->as_string, 'http://localhost:9091/rs/product/Store', 'baseDatasourceUrl');
    is($Client->encodeRequest({'a'=>'b'}), encode_json({'a'=>'b'}), 'encodeRequest' );
    is_deeply($Client->decodeResponse('{"a":"b"}'), decode_json('{"a":"b"}'), 'decodeRequest' );
}

####### Main ############
RunScript(
    Sub => sub {
        Test::Class->runtests;
      }
);
