-- #105
CREATE TABLE shippingvalues (
     shippingvaluesid     integer  not null AUTO_INCREMENT
,    shippingmethodid     integer  not null
,    currencyid           char(3)  not null
,    maximumweight        double  null
,    freeshippingprice    decimal(19,4)  null

,   constraint pk_shippingvalues                primary key (shippingvaluesid)
,   constraint fk_shippingvalues_shippingmethodid foreign key (shippingmethodid)
        references shippingmethod                   (shippingmethodid)
,   constraint fk_shippingvalues_currencyid     foreign key (currencyid)
        references currency                         (currencyid)
)
GO
CREATE UNIQUE INDEX i_shippingvalues_shippingmethod ON shippingvalues (shippingmethodid, currencyid)
GO

CREATE INDEX i_shippingvalues_currencyid ON shippingvalues (currencyid)
GO
