jQuery.plugin('de_epages.shopmailtype.ui.editmailaddress',
{
	plugin : ['jQuery.ui.widget', 'de_epages.core', 'ep.ui.simpledialog', 'ep.ui.validate', 'ep.ui.input']
}, function ($) {
	// Template.
	$.template('de_epages.shopmailtype.inc.editinputrow','<div><div class="InputRow">' +
  	'<label class="AlignRight" for="email">${$item.wording.email} <span class="MandatoryStar">*</span></label>' +
    '<input type="email" name="email" id="email" required="required" {{if $item.data.email}}value="${email}"{{/if}} />' +
    '<span title="${$item.wording.deleteMail}" class="ep-sprite ico_s_delete ClickIcon LeftMargin"></span></div> <div class="InputRow BottomMargin">' +
  	'<label class="AlignRight" for="name">${$item.wording.name}</label>' +
    '<input type="text" name="name" id="name" {{if $item.data.name}}value="${name}"{{/if}} />' +
    '</div></div>');

	// Widget.
	$.widget('de_epages.shopmailtype.ui.Editmailaddress', {

		options : {
			wording : {},
			data : {'dummy' : []},
			name : 'dummy',
			multiple : true,
			showSetDefault : false
		},

		_create : function () {
			var self = this,
					o = self.options;

			// Merge in options from data attribute.
			$.extend(true, o, $.parseJSON(self.element.attr('data-de_epages-shopmailtype-ui-editmailaddress')));

			// Set corresponding input element.
			if (!o.name){
				return self.destroy();
			}

			self.input = $('input[name="' + o.name + '"]');

			// Render template.
			self.content = $('<form>').append($.tmpl('de_epages.shopmailtype.inc.editinputrow', o.data[o.name].length ? o.data[o.name] : [{}] , {wording : o.wording}));
			// Init delete event listeners.
			self.content.on('click', '.ico_s_delete', self.Proxy('_deleteMail'));

			// Init *uiValidate* and *uiInput*.
			ep(self.content.find('input[type="email"]')).uiValidate({type : 'email'});
			ep(self.content.find('input[type="text"]')).uiInput();

			// Add footer.
			// i.e. *setDefault* checkbox or *addMail* button.
			self.footer = $('<footer>');
			if (o.multiple) {
				$('<span  style="padding-left:158px;" class="DisplayBlock PseudoLink CursorPointer">')
					.text(o.wording.addMail)
					.on('click', self.Proxy(self._addMail))
					.appendTo(self.footer);
			}
			else {
				if (o.showSetDefault) {
					// Init and render template.
					!$.template['de_epages.shopmailtype.inc.setdefault'] &&	$.template('de_epages.shopmailtype.inc.setdefault','<div class="InputRow">' +
						'<input type="checkbox" name="setdefault" id="setdefault"/>' +
						'<label class="InputLabellingXWide AlignLeft" for="setdefault">${$item.wording.setDefault}</label>' +
      			'</div>');

      		self.setDefault = $.tmpl('de_epages.shopmailtype.inc.setdefault', {}, {wording : o.wording})
      			.appendTo(self.footer)
      			.find('input[type="checkbox"]')
      			.sub(ep).uiInput();
      	}
			}

			// Init *uiSimpleDialog*.
			self.element = ep(self.element).uiSimpledialog({
				content : [self.content[0], self.footer[0]],
				buttons : [{
					text : o.wording.apply,
					callback : function () {
						if (self.content.find('input[type="email"]:invalid').length) {
							ep(self.content.find('input[type="email"]:invalid')).trigger('validate.uiValidate');
							return;
						}
						else {
							self._apply();
							self._close();
						}
					}
				}]
			});
		},

		_deleteMail : function (event) {
				event.stopPropagation();
				// Otherwise *self.dialog._close()* is called, since
				// the click was fired by an element which at that point
				// is no longer part of the dialog.
				$(event.target).parent().next().remove();
				$(event.target).parent().remove();
		},

		_addMail : function () {
			var self = this,
					o = self.options,
					inputrow = $.tmpl('de_epages.shopmailtype.inc.editinputrow', {}, {wording : o.wording});

			// Init *uiValidate* and *uiInput*.
			ep(inputrow.find('input[type="email"]')).uiValidate({type : 'email'});
			ep(inputrow.find('input[type="text"]')).uiInput();

			inputrow.appendTo(self.content);
		},

		_apply : function () {
			var self = this,
					o = self.options,
					value = '',
					inputs = self.content.find('input[type="text"], input[type="email"]'),
					names = inputs.filter('[type="text"]'),
					name = '',
					doajax =  self.setDefault && self.setDefault.is(':checked');

			// Let us add all those emails and names together.
			inputs.filter('[type="email"]').each(function (index, email){
				email = email.value;
				name = names[index].value;
				// Set default Sender Address, if the checkbox is checked.
				if ((index === 0) && doajax){
				  ep.ajax({
					type : 'POST',
					dataType : 'json',
					data : {
						'DefaultEmail' : email,
						'DefaultName' : name,
						'ViewAction' : 'JSONViewResponse',
						'ChangeAction' : 'JSONMakeDefaultSender',
						'ObjectID' : ep.config.objectId
					}
				});}
				value = value + (value ? ';' : '') + name + (name ? ' <' : '') + email + (name ? '>' : '');
			});

			// Output email string into input.
			self.input.val(value);
		},

		_close : function () {
			this.element.uiSimpledialog('close');
		},

		destroy : function () {
			var self = this;
			self.content && self.content.remove();
			self.element.uiSimpledialog('destroy');
			self.Inherited(arguments);
		}

	});

});