jQuery.plugin('de_epages.shopmailtype.ui.placeholderdialog',
{
	plugin : ['jQuery.ui.widget', 'jQuery.datatables', 'jQuery.tmpl', 'de_epages.core', 'ep.ui.simpledialog']
}, function ($) {
	// Template.
	$.template('de_epages.shopmailtype.ui.placeholderdialog', '{{if $item.data.wording && wording.infoText}}<p>${wording.infoText}</p>{{/if}}<table {{elem "table"}}></table>');

	// Widget.
	$.widget('de_epages.shopmailtype.ui.Placeholderdialog', {

		options : {
			data : {
				placeholder : []
			},
			name : 'Subject'
		},

		_create : function () {
			var self = this,
					o = self.options;

			// Merge in options from data attribute.
			$.extend(true, o, $.parseJSON(self.element.attr('data-de_epages-shopmailtype-ui-placeholderdialog')));

			// Render template.
			self.content = $.tmpl('de_epages.shopmailtype.ui.placeholderdialog', o);
			self.table = $.tmplItem(self.content).elements.table;

			// Set table *data* and *input* name.
			self._setOptions({
				data : o.data,
				name : o.name
			});

			// Add tr click listener. We pass the widget as an attribute of
			// the data attribute of the event object to the listener, since
			// we need *this* to be the *tr* element firing the click.
			self.table.on('click', 'tbody tr', {self : self}, self._onTrClick);

			// Init dialog.
			self.element = ep(self.element).uiSimpledialog({
				content : self.content
			});
		},

		_setOption : function (key, value) {
			var self = this,
					o = self.options;

			if (key === 'data' && value.placeholder) {
				// Init *tableData*.
				var i,
						tableData = {
							aaData : [],
							aoColumns : [
								{sTitle : o.wording.placeholder}
							]
						};

				for (i = 0; i < value.placeholder.length; i++) {
					var _placeholder = value.placeholder[i];
					tableData.aaData[i] = [_placeholder.description, _placeholder.code];
				}

				// Clear table.
				$.fn.DataTable.fnIsDataTable(self.table[0]) && self.table.dataTable().fnDestroy();

				// Init table.
				self.table.dataTable(tableData);
			}
			else {
				if (key === 'name') {
					// Set input.
					self.input = $('input[name="' + value + '"]').first();
				}
			}

			self.Inherited(arguments);
		},

		_close : function () {
			this.element.uiSimpledialog('close');
		},

		_onTrClick : function (event) {
			// The instance of the widget is *self* (as per the usual).
			// *this* is the *tr* element firing the click event.
			var self = event.data.self,
					o = self.options,
					placeholder = o.data.placeholder[self.table.fnGetPosition(this)].code,
					beginning = self.input.val().substring(0, self.input.prop('selectionStart')),
    		 	end = self.input.val().substring(self.input.prop('selectionEnd')),
    		 	newPosition = self.input.prop('selectionStart') + placeholder.length;

			// Insert placeholder into *input*.
    	self.input
    		.val(beginning + placeholder + end)
				.prop({
    			'selectionStart' : newPosition,
    			'selectionEnd' :  newPosition
    		})
    		.focus();

			// Close the dialog.
			self._close();
		},

		destroy : function () {
			var self = this;
			self.table && $.fn.DataTable.fnIsDataTable(self.table) && self.table.dataTable().fnDestroy();
			self.content && self.content.remove();
			self.element.data('epUiSimpledialog') && self.element.uiSimpledialog('destroy');
			self.Inherited(arguments);
		}

	});

});